﻿using VCommon.Linq.Expressions.Predicate;
using VCommon.VApplication.EntityFrameworkCore;
using VCommon.VEntity;
using VCommonCoreExample.EntityFrameworkCore;

namespace VCommonCoreExample.AppServices.Basic
{
    public class DbAppServiceBase : AppServiceBase
    {
        protected ExampleDbContext GetDbContext() => IocManager.Resolve<ExampleDbContext>();
    }

    public class DbTableAppServiceBase<TEntity> : AppServiceBase where TEntity : VEntityBase
    {
        protected static readonly PredicateBuilder<TEntity> PredicateBuilder = PredicateBuilder<TEntity>.Instance;

        protected VAppEfRepository<ExampleDbContext, TEntity> GetRepository(string disableFilter = null) => GetRepository<TEntity>(disableFilter);

        protected VAppEfRepository<ExampleDbContext, TOtherEntity> GetRepository<TOtherEntity>(string disableFilter = null) where TOtherEntity : VEntityBase
        {
            var repo = IocManager.Resolve<VAppEfRepository<ExampleDbContext, TOtherEntity>>();
            if (disableFilter != null) repo.DisableFilter(disableFilter);
            return repo;
        }
    }
}
