﻿using System.Collections.Generic;
using VCommon.VApplication.Auditing.DataAnnotations;
using VCommon.VApplication.Dto;

namespace VCommonCoreExample.AppServices.System.Roles.Dto
{
    public class RoleListOutput : IPagedResult<RoleDto>
    {
        public RoleListOutput(int totalRecord, IReadOnlyList<RoleDto> items)
        {
            TotalRecord = totalRecord;
            Items = items;
        }

        public int TotalRecord { get; }

        [SimplifyAuditingLog]
        public IReadOnlyList<RoleDto> Items { get; }
    }
}