﻿using System.Collections.Generic;
using VCommon.VApplication.Auditing.DataAnnotations;
using VCommon.VApplication.Dto;

namespace VCommonCoreExample.AppServices.System.Users.Dto
{
    public class UserListOutput : IPagedResult<UserDto>
    {
        public IReadOnlyCollection<NamedEntityDto> AvailableRoles { get; set; }

        public UserListOutput(int totalRecord, IReadOnlyList<UserDto> items)
        {
            TotalRecord = totalRecord;
            Items = items;
        }

        public int TotalRecord { get; }

        [SimplifyAuditingLog]
        public IReadOnlyList<UserDto> Items { get; }
    }
}