﻿using System;
using VCommon.Logging;
using VCommon.VApplication.Auditing.Json;

namespace VCommonCoreExample.Audit
{
    public class ServiceAuditInterceptor : JsonApplicationServiceAuditInterceptorBase
    {
        protected override void WriteJsonAuditLog(Guid? tenantId, Guid? userId, string serviceClassName, string serviceMethodName, string input, string output, string exception)
        {
            Logger.Trace("Audit", new
            {
                InvokeTiming.BeginInvokeTime,
                InvokeTiming.Elapsed.TotalMilliseconds,
                tenantId,
                userId,
                serviceClassName,
                serviceMethodName,
                Input = VJsonLogSerializer.Instance.DeserializeObject<object>(input),
                Output = VJsonLogSerializer.Instance.DeserializeObject<object>(output),
                Exception = VJsonLogSerializer.Instance.DeserializeObject<object>(exception)
            });
        }
    }
}
