﻿using System;
using VCommon.Ioc;
using VCommon.VApplication.Authorization;

namespace VCommonCoreExample.Authorization
{
    public class PermissionChecker : ISingletonIocClass, IPermissionChecker
    {
        private readonly PermissionProvider _provider;

        public PermissionChecker(PermissionProvider provider)
        {
            _provider = provider;
        }
        public bool CheckPermission(Guid? tenantId, Guid userId, params string[] hasAnyPermission)
        {
            return _provider.CheckPermission(tenantId, userId, hasAnyPermission);
        }
    }
}