﻿using Microsoft.EntityFrameworkCore;
using System;
using VCommon.VApplication.Dto;
using VCommon.VEntity;

namespace VCommonCoreExample.Entity
{
    [Index(nameof(TenantId))]
    public class Role : VEntityBase, IMayHaveTenant, IHaveName, ISoftDelete, IFullAuditEntity
    {
        public Guid? TenantId { get; set; }
        public string Name { get; set; }

        /// <summary>
        /// 权限集合 JSON Array of String
        /// </summary>
        public string PermissionSet { get; set; }

        public bool IsAbolish { get; set; }
        public DateTime CreationTime { get; set; }
        public Guid CreationUserId { get; set; }
        public DateTime? LastModificationTime { get; set; }
        public Guid? LastModificationUserId { get; set; }
    }
}
