﻿using Microsoft.EntityFrameworkCore;
using System;
using System.ComponentModel.DataAnnotations;
using VCommon.VApplication.Dto;
using VCommon.VEntity;

namespace VCommonCoreExample.Entity
{
    [Index(nameof(TenantId))]
    [Index(nameof(TenantId), nameof(LoginName), IsUnique = true)]
    public class User : VEntityBase, IMayHaveTenant, IHaveName, IPassive, ISoftDelete, IFullAuditEntity
    {
        public Guid? TenantId { get; set; }

        /// <summary>
        /// JSON Array of Guid
        /// </summary>
        [Required]
        public string Roles { get; set; }

        [Required]
        public string Name { get; set; }

        [Required]
        public string LoginName { get; set; }

        [Required]
        public string Password { get; set; }

        public bool IsStaticUser { get; set; }

        public bool IsEnable { get; set; }

        public bool IsAbolish { get; set; }
        public DateTime CreationTime { get; set; }
        public Guid CreationUserId { get; set; }
        public DateTime? LastModificationTime { get; set; }
        public Guid? LastModificationUserId { get; set; }
    }
}
