﻿using Microsoft.EntityFrameworkCore;
using System;
using VCommon.VApplication.EntityFrameworkCore;
using VCommonCoreExample.Configuration;
using VCommonCoreExample.Entity;

namespace VCommonCoreExample.EntityFrameworkCore
{
    public class ExampleDbContext : VAppDbContextBase
    {
        public DbSet<Organization> Organizations { get; set; }

        public DbSet<Role> Roles { get; set; }

        public DbSet<Tenant> Tenants { get; set; }
        public DbSet<User> Users { get; set; }

        public DbSet<UserInOrganization> UserInOrganizations { get; set; }

        public ExampleDbContext(DbContextOptions<ExampleDbContext> options) : base(options)
        {
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<User>().HasData(new User
            {
                TenantId = null,
                Id = new Guid(1, 2, 3, 4, 5, 6, 7, 8, 9, 0xa, 0xb),
                LoginName = ProjectConst.BuildInAdminUserName,
                Name = ProjectConst.BuildInAdminUserName,
                IsEnable = true,
                IsStaticUser = true,
                Roles = "[]",
                Password = "AIk0zKJKWH+8N9+hHWFFZ5U26GVyNG0V+9vNUDmuX6P6XnWeQXhd3cTV0jcM/DIi8A==", // 123qwe, PasswordHasher
            });

            base.OnModelCreating(modelBuilder);
        }
    }
}
